#include "screen.h"
#include <conio.h>
#include <pc.h>

Screen::Screen()
{
    if (!number_of_objs)
    {
        clrscr();
        former_attrib = ScreenAttrib;
        _setcursortype(_NOCURSOR);
    }
    number_of_objs++;
}

int Screen::number_of_objs = 0;
int Screen::width = 80;
int Screen::height =35;
unsigned char Screen::former_attrib;

void Screen::update(int x1,int y1,int x2, int y2)
{
    //does nothing in text mode
}

int Screen::screenheight()
{
    return height;
}

int Screen::screenwidth()
{
    return width;
}

void Screen::remove_screen_now()
{
        textattr(former_attrib);
        _setcursortype(_NORMALCURSOR);
        clrscr();
}

Screen::~Screen()
{
    number_of_objs--;
    if (!number_of_objs)
    {
        textattr(former_attrib);
        _setcursortype(_NORMALCURSOR);
        clrscr();
    }
}

void Screen::print(int x, int y, int color, char *string)
{
    gotoxy(x, y);
    textattr(color);
    cputs(string);
}

void Screen::clear_screen()
{
    clrscr();
}

void Screen::box(int x1, int y1, int x2, int y2, int color)
{
    int swptmp;
    if (x1 > x2)
    {
        swptmp = x1;
        x1 = x2;
        x2 = swptmp;
    }
    if (y1 > y2)
    {
        swptmp = y1;
        y1 = y2;
        y2 = swptmp;
    }
    textattr(color);
    for (int x = x1; x <= x2; x++)
    {
        gotoxy(x, y1);
        putch(219); //blokje
        gotoxy(x, y2);
        putch(219); //blokje
    }
    for (int y=y1 + 1; y < y2; y++)
    {
        gotoxy(x1, y);
        putch(219); //blokje
        gotoxy(x2, y);
        putch(219); //blokje
    }
    for (int x = x1 + 1; x < x2; x++)
    {
        for (int y = y1 + 1; y < y2; y++)
        {
            gotoxy(x, y);
            putch(32);
        }
    }

}
void Screen::box8(int x1, int y1, int x2, int y2, int color)
{
    box(x1 / 8 + 1, y1 / 8 + 1, x2 / 8 + 1, y2 / 8 + 1, color);
}

void Screen::filledbox(int x1, int y1, int x2, int y2, int color)
{
    int swptmp;
    if (x1 > x2)
    {
        swptmp = x1;
        x1 = x2;
        x2 = swptmp;
    }
    if (y1 > y2)
    {
        swptmp = y1;
        y1 = y2;
        y2 = swptmp;
    }
    textattr(color);
    for (int x = x1; x <= x2; x++)
    {
        for (int y = y1; y <= y2; y++)
        {
            gotoxy(x, y);
            putch(219);
        }
    }

}

void Screen::filledbox8(int x1, int y1, int x2, int y2, int color)
{
    filledbox(x1 / 8 + 1, y1 / 8 + 1, x2 / 8 + 1, y2 / 8 + 1, color);
}
