#ifndef _scrollbar_h_
#define _scrollbar_h_
#include "perror.h"

#define VERTICAL 0
#define HORIZONTAL 1

class Scrollbar : public Perror
{
    public:
        Scrollbar();                                        
        Scrollbar(int length, int real_length, int x_upper_left, int y_upper_left, int orientation);
        int shift(int how_much);
        int shift_to(int location);
        void reset_real_length(int new_length);

    private:
        int x, y;
        int screen_length;
        int real_length;
        int orientation;
        int position;
        void draw();

};



#endif
