#ifndef _screen_h_
#define _screen_h_


class Screen
{
    public:
        Screen();
        ~Screen();

        // calls the destructor as if you remove the last screen object
        //after this you should not use any of the screen functions any more
        void remove_screen_now();

        //textout
        static void print(int x, int y, int color, char *string);
        static void clear_screen();

        //draw boxes
        static void box(int x1, int y1, int x2, int y2, int color);
        static void filledbox(int x1, int y1, int x2, int y2, int color);

        //draw boxes in pixelcoordinates(for compatibility width graphic version)
        static void box8(int x1, int y1, int x2, int y2, int color); 
        static void filledbox8(int x1, int y1, int x2, int y2, int color);

        static int screenheight();
        static int screenwidth();
        static void update(int x1,int y2,int x2,int y2);
    private:
        static int number_of_objs;
        static int width;
        static int height;
        static unsigned char former_attrib;
};

#endif
